use AdventureWorks2012
GO

-- total number of records
select COUNT(*) from Production.TransactionHistory
GO


SELECT TOP 10
	TransactionID
	, ProductID
	, TransactionDate
	, Quantity
	, ActualCost
FROM
	Production.TransactionHistory;

-- is the above code deterministic?


--Display 20 rows per page by most recent transactions

SELECT
	TransactionID,
	ProductID,
	TransactionDate,
	Quantity,
	ActualCost
	FROM
	Production.TransactionHistory
	ORDER BY TransactionDate DESC
	OFFSET 0 ROWS
	FETCH NEXT 20 ROWS ONLY;


	-- next 20

	SELECT
	TransactionID,
	ProductID,
	TransactionDate,
	Quantity,
	ActualCost
	FROM
	Production.TransactionHistory
	ORDER BY TransactionDate DESC
	OFFSET 20 ROWS
	FETCH NEXT 40 ROWS ONLY;

	-- ANSI compatibility; FIRST can be used !

		SELECT
	TransactionID,
	ProductID,
	TransactionDate,
	Quantity,
	ActualCost
	FROM
	Production.TransactionHistory
	ORDER BY TransactionDate DESC
	OFFSET 20 ROWS
	FETCH FIRST 40 ROWS ONLY;


	-- compariosn with CTE

	WITH Paging_CTE AS
	(
	SELECT
		TransactionID,
		ProductID,
		TransactionDate,
		Quantity,
		ActualCost,
		ROW_NUMBER() OVER (ORDER BY TransactionDate DESC) AS RowNumber
	FROM
		Production.TransactionHistory
	)
	SELECT
		TransactionID,
		ProductID,
		TransactionDate,
		Quantity,
		ActualCost
	FROM
		Paging_CTE
	WHERE
		RowNumber > 0 AND RowNumber <= 20


		-- and you can use varibales, create procs, etc...

		DECLARE @OffsetRows tinyint = 0,
				@FetchRows tinyint = 20;
			  
		SELECT
				TransactionID,
				ProductID,
				TransactionDate,
				Quantity,
				ActualCost
		FROM	Production.TransactionHistory
		ORDER BY TransactionDate DESC
				
		OFFSET @OffsetRows ROWS
		FETCH NEXT @FetchRows ROWS ONLY;